Program PTT;

{----------------------------------------------------------TP 6.0 or later--}
{                                                                           }
{ Packet Tnc Try                                                   PTT v.00 }
{                                                                           }
{---------------------------------------------------------------------------}
{                                                                           }
{ Description:                                                              }
{                                                                           }
{           The program works on COM2 , $02F8 port of computer. This port   }
{           connects to a TNC or to a similar modem.It gives all code to    }
{           the TNC without filter (e.g.[Esc] or Alt-27  => Chr(27) go out) }
{           You can try the commands of microprogram in TNC or in Modem so. }
{           I was trying this program  on IBM PC 386   with  TNC2-TAPR  ,   }
{           TNC2-WA8DED , and GVC-2400 v.42 bis/MNP5 modems.                }
{                                                                           }
{ Lers :                                                                  }
{                                                                           }
{           A program a szamitogep COM2 , $02F8 portjara csatlakozo TNC-vel }
{           vagy hasonlo modemmel dolgozik. Minden kodot szures nelkul atad }
{           a TNC-nek ( pld.  [Esc] vagy Alt-27   =>   Chr(27) megy ki ).   }
{           Igy kiprobalhatod a TNC-ben vagy a modemben lev mikroprogram   }
{           parancsait. En ezt a programot egy IBM PC 386 -on   TNC2-TAPR , }
{           TNC2-WA8DED s GVC-2400 v.42 bis/MNP5 modemekkel probaltam ki.  }
{                                                                           }
{           55 ...                                       HG3FTN @HA3PMF.EU  }
{                                                                           }
{---------------------------------------------------------------------------}

{$M 16000,0,0}
USES Crt,Graph,Dos;

CONST   {-------------------------------------------------Global constans---}

   ComSelect      = 2;        { COM2                please 1 to select COM1 }
   ComParam       = $CA;      { 4800,Odd,One,7 bits       see below PortIni }
   Buff1_size     = 32*1024;
   Click          = True;
   HexChar        : string  = '0123456789ABCDEF';

TYPE    {-------------------------------------------------------Some type---}
   Scr            = record
                    br    : byte;
                    text  : byte;
                    x     : byte;
                    y     : byte;
                    wx1   : byte;
                    wy1   : byte;
                    wx2   : byte;
                    wy2   : byte;
                    end;

   SetUp          = record
                    com   : byte;
                    irq   : byte;
                    port  : word;
                    ini   : byte;
                    stat  : word;
                    end;

   ByteCmd        = record
                    exit  : byte;
                    end;

   buff1t         = array[1..buff1_size] of CHAR;

VAR     {------------------------------------------------Global variables---}

   regs           : registers;
   OldIrqVec      : Procedure;
   Tnc1           : SetUp;                              {   The first TNC   }
   RxScr          : Scr;
   StScr          : Scr;
   TxScr          : Scr;
   TastCmd        : ByteCmd;
   InsMode        : Boolean;
   Buff1          : buff1t;
   Buff1_put      : Integer;
   Buff1_get      : Integer;
   Dr,Be          : byte;
   Cmd            : string;

{$F+}
PROCEDURE ComxRead ; interrupt;  {-------------------------------ComX IRQ---}
VAR
   ByteRead : byte;
begin
   If (buff1_put<=Buff1_size) or
      (buff1_put-Buff1_Size<=buff1_Get) then
   begin
      INLINE($FA);
      ByteRead:=PORT[tnc1.port];
         IF ByteRead>0 THEN
            Begin
            buff1_put:=buff1_put+1;
            If Buff1_Put<=Buff1_size
               then buff1[buff1_put]:=Chr(ByteRead)
               else buff1[buff1_put-buff1_size]:=Chr(ByteRead);
            end;

      PORT[$20] := $20;  { use non-specific EOI }
      INLINE($FB);
      OldIrqVec;
   end;
end;
{$F-}

FUNCTION PortIni(tnc:setup):word; {-------------------ComX Inicialization---}

{     Baud rate         Parity          Stop bits       Word Length

Bit   7 6 5             4 3             2               1 0

      0 0 0    110      0 0  None       0  One          1 0  7 bits
      0 0 1    150      0 1  Odd        1  Two          1 1  8 bits
      0 1 0    300      1 0  None
      0 1 1    600      1 1  Even
      1 0 0  1,200      
      1 0 1  2,400                e.g.: $8A :  1200,Odd,One,7 bits
      1 1 0  4,800                      $AA :  2400,Odd,One,7 bits
      1 1 1  9,600                      $CA :  4800,Odd,One,7 bits
}

begin
   regs.ah:=$00;
   regs.al:=tnc.ini;
   regs.dx:=tnc.com;
   intr($14,regs);
   PortIni:=regs.ax;
end;

FUNCTION hexa(dec:byte):string;    {----------------Dec -> Hex conversion---}
var
   hex1,hex2 : byte;
begin
   hex1:=(dec and $F0) div 16;
   hex2:=dec and $0F;
   hexa:=HexChar[hex1+1]+HexChar[hex2+1];
end;

PROCEDURE MakeScr; {-----------------------------Screen size,position ini---}
begin

   NormVideo;
   ClrScr;
   Textcolor(StScr.text);TextBackground(StScr.br);
   GotoXY(StScr.wx1,StScr.wy1);
   WRITE('COM',Tnc1.com+1:1,',IRQ',Tnc1.Irq:1,',$',
         hexa(((Tnc1.port) and ($FF00)) div 256),
         hexa((Tnc1.port) and ($00FF)),',INI:$',
         hexa(Tnc1.ini),' ':40,'PTT v.00 Alt-X ');

   WINDOW(RxScr.wx1,RxScr.wy1,RxScr.wx2,RxScr.wy2);
   NormVideo;
   {Textcolor(RxScr.text);TextBackground(RxScr.br);}
   CLRSCR;
   GOTOXY(1, 4);WRITELN('                  -=   Packet Tnc Try  Ver.00 by HG3FTN   =-                  ');
   GOTOXY(1, 6);WRITELN('                               Copyright (c) 1993                               ');
   GOTOXY(RxScr.x,RxScr.y);

   WINDOW(TxScr.wx1,TxScr.wy1,TxScr.wx2,TxScr.wy2);
   GotoXY(TxScr.x,TxScr.y);
end;

PROCEDURE Buff1Write;   {---------------------------------Buff1 to Screen---}
begin
       IF buff1_put>=buff1_get+1 then
          begin
               buff1_get:=buff1_get+1;
               If buff1_get>buff1_size then begin
                                       buff1_get:=1;
                                       buff1_put:=buff1_put-buff1_size;end;

               TxScr.x:=WhereX;TxScr.y:=WhereY;
               WINDOW(RxScr.wx1,RxScr.wy1,RxScr.wx2,RxScr.wy2);
               GotoXY(RxScr.x,RxScr.y);

               Write(buff1[buff1_get]);

               RxScr.x:=WhereX;RxScr.y:=Wherey;
               WINDOW(TxScr.wx1,TxScr.wy1,TxScr.wx2,TxScr.wy2);
               GotoXY(TxScr.x,TxScr.y);


               If Click and (buff1[buff1_get]=CHR(13)) then
                  begin
                       Sound(1000);
                       Delay(2);
                       Nosound;
               end;

          end;
end;

FUNCTION SelfRead(x,y,l:integer):string; {------------------READ a STRING---}

                                         { x,y : Koordinate to Read         }
                                         { l   : Length of string   max:=80 }

var
   Sg        : string;
   StrPoz    : integer;
   StrLen    : integer;
   StrLenOld : integer;
   e         : integer;
   ch        : char;
begin
   StrPoz:=1; sg:='';StrLen:=Length(sg);
   GotoXY(x,y);
   ch:=' ';
   While (StrLen<l) and (ch<>chr(13)) and (TastCmd.eXit=0) do
         begin
         StrLenOld:=StrLen;
      If keypressed Then
         begin
         ch:=readkey;

    {to test }{        write('<',ORD(ch),'>');}

             If ch=#0 then
                begin
                ch:=readkey;
                Case ch of

    {--Key---!-----------------------------------------------Edit keys 1)---}

    {CrsLeft }       'K'     : If StrPoz>  1 then StrPoz:=StrPoz-1;
    {CrsRight}       'M'     : If StrPoz<=StrLen then StrPoz:=StrPoz+1;
    {Home    }       'G'     : StrPoz:=1;
    {End     }       'O'     : StrPoz:=StrLen+1;
    {Del     }       'S'     : If StrPoz<=StrLen then
                               begin
                                  Delete(sg,StrPoz,1);
                                  If Length(sg)=StrPoz then StrPoz:=StrPoz+1;
                               end;
    {Ins     }       'R'     : If StrPoz<=StrLen then InsMode:= not (InsMode);

    {--Key---!--------------------------------------------Tast Commads 1)---}

    {Alt-X   }       '-'     : begin TastCmd.exit:=1; sg:='' end;
                end;
    {to test }{        write('-',ch,'-');}

             end  {If ch=#0}
             else begin

    {--Key---!-----------------------------------------------Edit keys 2)---}
                Case ORD(ch) of
     {BackSp }       8    : begin
                               If StrPoz>  1 then StrPoz:=StrPoz-1;
                               Delete(sg,StrPoz,1);
                            end;
     {Return }       13   :

                     else   begin
                               IF (StrPoz<=StrLen) and (ch<>CHR(13))
                                  then
                                      If InsMode then insert(ch,sg,StrPoz)
                                      else sg[StrPoz]:=ch
                                  else sg:=sg+ch;
                               StrPoz:=StrPoz+1;
                            end;
                end;

             end;   {If ch=#0}

             StrLen:=Length(sg);

             If StrPoz=1 then e:=0 else e:=1;
             GotoXY(x+StrPoz-1-e,y);
             Write(Copy(sg,StrPoz-e,StrLen-(StrPoz-1-e)));
             If StrLen<StrLenOld then Write(' ');

             GotoXY(x+StrPoz-1,y);

         end else Buff1Write;

   end;   {while ... do}
   Writeln;

   {- The Chr(3) is a command mode code of TAPR P , it don't need Chr(13) -}

   If (StrLen>0) and (sg[1]<>Chr(3)) or
      (StrLen=0) and (TastCmd.eXit=0) THEN sg:=sg+CHR(13);

   SelfRead:=sg;

end;



{==============================   MAIN   ===================================}

begin

   {------------------------------------------------------------ComSelect---}
   Case ComSelect of
        1: begin
           Tnc1.com:=00;Tnc1.irq:=04;Tnc1.port:=$03f8;Tnc1.ini:=ComParam;
           end;
        2: begin
           Tnc1.com:=01;Tnc1.irq:=03;Tnc1.port:=$02f8;Tnc1.ini:=ComParam;
           end;
   end;

   If (Port[Tnc1.port+$02])and($F8)=0 Then
   begin
   Tnc1.stat:=PortIni(tnc1);

   {-----------------------------------------------------------Irq modify---}
   GetIntVec(Tnc1.irq+8,@OldIrqVec);
   SetIntVec(Tnc1.irq+8,Addr(ComxRead));
   Intr(Tnc1.irq+8,regs);                      { The first Intr need to TNC }

   {----------------------------------------------------TastCmdstatus ini---}
   TastCmd.eXit:=0;

   {----------------------------------------------------------Screens ini---}
   RxScr.br:= 0;RxScr.text:=15;
                RxScr.wx1:= 1;RxScr.wy1:= 1;RxScr.wx2:=80;RxScr.wy2:=20;
                RxScr.x:= 1;RxScr.y:=RxScr.wy2-RxScr.wy1;
   StScr.br:=15;StScr.text:= 0;
                StScr.wx1:= 1;StScr.wy1:=21;StScr.wx2:=80;StScr.wy2:=21;
   TxScr.br:= 0;TxScr.text:=15;
                TxScr.wx1:= 1;TxScr.wy1:=22;TxScr.wx2:=80;TxScr.wy2:=25;
                TxScr.x:= 1;TxScr.y:= TxScr.wy2-TxScr.wy1;
   MakeScr;

   InsMode:=False;  buff1_get:=0;  buff1_put:=0;  CMD:='';


   INLINE($FA);   {disable interrupts}
            PORT[Tnc1.port+3]:=PORT[Tnc1.port+3] AND $7F;
            BE:=PORT[Tnc1.com];
            {---------------------------------set interrupt mask register---}
            DR :=PORT[$21];
            BE := (1 SHL Tnc1.irq) XOR $00FF;
            PORT[$21]:= DR AND BE;
            {-----------------enable the data available interrupt on 8250---}
            PORT[Tnc1.port+1]:=PORT[Tnc1.port+1]or$01;
            PORT[Tnc1.port+4]:=PORT[Tnc1.port+4]or$08;
   INLINE($FB);   { enable interrupts}


   REPEAT {----------------------------------------------------MAIN cycle---}

       { --- 1) read a line from tast ------------------------ }

       IF keypressed and (length(cmd)=0) then begin
          cmd:=SelfRead(WhereX,Wherey,80);
       end;

       { --- 2) put one character from IO buffer to display--- }

       Buff1Write;

       { --- 3) put one character to serial port ------------- }

       If (length(cmd)>0) then
          begin
             INLINE($FA);
                    PORT[Tnc1.port+4]:=PORT[Tnc1.port+4]or$0B;
                    PORT[Tnc1.port]:=ORD(CMD[1]);
                    DELETE(CMD,1,1);
                    DELAY(2);
                    PORT[Tnc1.port+4]:=PORT[Tnc1.port+4]or$08;
             INLINE($FB);
          end;

   UNTIL TastCmd.exit=1; {------------------------------end of MAIN cycle---}

   {----------------------------------------------------set the originals---}
   SetIntVec(Tnc1.irq+8,Addr(OldIrqVec));

   WINDOW(1,1,80,25);
   GOTOXY(1,25);

   end
   else Writeln('Sorry , serial port not installed ...');


{  If you feel like it , you can continue ...                               }
{                                                                           }
{  Ha van kedved , folytathatod ...                                         }
{                                                                           }
{                                    73 & many Links ... de HG3FTN , Janos  }
{                                                                           }


end.